from TempoCalendar3 import *   #天保暦用追加
from Holidays import * #休日用追加
from Gengo4 import * #
import time
from tkinter import *
from tkinter import messagebox
tk=Tk();tk.title("暦(旧暦表示)")#タイトル表示
canvas=Canvas(tk, width=400, height=350)#高さを若干増やす
canvas.pack()
tk2=Tk();tk2.title("元号一覧")
canvas2=Canvas(tk2, width=1100, height=380)#(2018/11/10)
canvas2.pack()
tk2.withdraw(); mouseXY=[False,0,0]#ウインドウを隠してマウス操作無効
def drawGtext(X,Y,TXT, SIZE,CL):
    canvas2.create_text(X,Y,text=TXT,font=('HG教科書体',SIZE,'bold'),
                                tag='date',fill=CL)
def dspGengo():#元号一覧表示
    tk2.deiconify(); mouseXY[0]=True #ウィンドウを表示してマウス操作有効
    canvas2.delete('date')  # 前表示の日付削除(タグ='date')
    Y=1; X=-40; k=0
    for i in range(len(GTab)):
        if k % 30 ==0: Y=12; X+=100 # 列変更
        if GTab[i][4]!="":          # 時代の表示
            DX=len(S)*10;
            drawGtext(X+DX+20,Y,GTab[i][4],8,'blue')
            Y+=11; k+=1
            if k % 30 ==0: Y=12; X+=100 # 列変更(2018/11/10)
        #2018/11/19
        if X==60 :drawGtext(X-20,Y, GTab[i][3] ,10,'black')#元号 
        else :    drawGtext(X   ,Y, GTab[i][3] ,10,'black')#元号
        YS="%4s" % GTab[i][0]
        if GTab[i][0]<=0: YS="BC%d" % (-GTab[i][0]+1)
        drawGtext(X+35,Y,YS,10,'black')#年
        drawGtext(X+55,Y,"%4d" % GTab[i][1],10,'black')#月
        Y+=11; k+=1
def exitProc2():#元号一覧が閉じられようとしたときウィンドウを隠すだけにする
    mouseXY[0]=False; tk2.withdraw()
def updTxtB(txt,DT):
    txt.delete("1.0","1.100"); txt.insert(INSERT, "%d" % DT)
def leftMouseDown(event):#左ボタンクリックのときの処理
    if mouseXY[0]:#マウス操作有効のとき
        X=int((event.x-40)/100); Y=int((event.y-7)/11)
        if X<0 or X>9 or Y<0 or Y>29: return 
        N=X*30+Y; k=0
        for i in range(len(GTab)):
            if GTab[i][4] !="": k+=1 #時代名が表記されているとき行カウント
            if (k+i)==N:             #該当する元号のとき
                updTxtB(txtY,GTab[i][0]);updTxtB(txtM,GTab[i][1])
                YS="%4d" % GTab[i][0]
                if GTab[i][0]<=0: YS="BC%d" % (-GTab[i][0]+1)

                if messagebox.askokcancel(
                    "暦表示",
                    "%s元年最初(%s/%d)の暦を表示しますか?" %
                    (GTab[i][3],YS,GTab[i][1])):
                    dspCalendar()    #暦表示
                break
def setColor(WD):
    CL='black'
    if WD==0: CL='red'
    if WD==6: CL='blue'
    return CL
def drawDate(X,Y,i,CL):
    canvas.create_text(X,Y, text=("%2d" % i),fill=CL,
                       font=('Helvetica',15,"bold"),tag='date')
def drawStartGengo(X,Y):
    canvas.create_rectangle(X+15,Y,X+35,Y+19,
                            tag='date',fill='#FFFF77',
                            outline='#FF7777')
Stab=("冬至","小寒","大寒","立春","雨水","啓蟄",
      "春分","清明","穀雨","立夏","小満","芒種",
      "夏至","小暑","大暑","立秋","処暑","白露",
      "秋分","寒露","霜降","立冬","小雪","大雪","冬至")
def monthSunT(Y,M):#月別節気リストの作成
    STerm=sunTermList(Y); T=[]
    for i in range(25):
        TIME=JDToWorld(STerm[i][0])
        if ((TIME[0]<1582) or
            (TIME[0]==1582 and TIME[1]<10) or
            (TIME[0]==1582 and TIME[1]==10 and TIME[2]<15)):
            TIME=GtoJ(TIME)
        if TIME[0]==Y and TIME[1]==M: T.append([TIME[2],Stab[i]])
    return T
def retSunT(Sterm,Day):#月別節気リストの検索
    for i in range(len(Sterm)):
        if Day== Sterm[i][0]: return Sterm[i][1]
    return ""
def drawVert(X,Y, S,YD,CL):#縦方向文字列表示
    YY=Y
    for i in range(len(S)):
        canvas.create_text(X,YY,text=S[i],
                           font=('HGSｺﾞｼｯｸE',7,'normal'),
                           tag='date',fill=CL)
        YY+=YD
def oldDate(Y, M, D):
    TIME=[Y,M,D]
    if((Y<1582)or(Y==1582 and M<10) or
       (Y==1582 and M==10 and D<15)):TIME=JtoG([Y,M,D])
    return getTempo(TIME[0],TIME[1],TIME[2])
def oldDateStr(DT):
    flag=False
    if DT[3]==1:flag=True
    return charCalender(DT,flag)
def Calendar(Y,M):
    SunFlag=False; SunT=monthSunT(Y,M)
    canvas.delete('date')
    DayOfWeek=["Sun","Mon","Tue","Wed","Thu","Fri","Sat"]
    chGengo[0]=0; chGengo[1]=0
    canvas.create_text(180,30,text=strGengo(Y,M),
                       font=('HG教科書体',8,'bold'),
                       tag='date',fill='purple')
    Date=[0,0,0]; Date[0]=Y; Date[1]=M; Date[2]=1
    Holidays=selectMounth(getHolidays(Y),M)
    for i in range(7):
        CL=setColor(i)
        canvas.create_text(30+i*50,50, text=DayOfWeek[i],fill=CL,
                           font=('Times',10),tag='date')
    canvas.create_line(10,60,360,60,fill='black',tag='date')
    if Y<1582 or (Y==1582 and M<=10): DW=JWeekDayZ(Date)
    else : DW=GWeekDayZ(Date)
    if Y<1582 or (Y==1582 and M<10):  MX=JMDates(Date)
    else :  MX=GMDates(Date)
    j=1
    if Y==1582 and M==10:   # 1582年10月の1行目の特殊処理
        for i in range(DW,7):
            if j==5: j+=10  # 1582年10月5のとき10日ずらす
            drawDate(25+i*50,90,j,setColor(i))
            if j==15:
                canvas.create_text(30+i*50,75,text="グレゴリオ暦改暦",
                                   font=('HGSｺﾞｼｯｸE',6,'normal'),
                                   tag='date',fill="red")
            oldDT=oldDate(Y,M,j)
            canvas.create_text(30+i*50,105,
                               text=oldDateStr(oldDT),
                               font=('HGSｺﾞｼｯｸE',6,'normal'),
                               tag='date',fill='black')
            drawVert(40+i*50,84,rokuyo(oldDT[2],oldDT[3]),10,'green')
            Sekki=retSunT(SunT,j)
            if Sekki!="":
                drawVert(12+i*50,84,Sekki,10,'purple')
                
            j+=1
    else :                  # 1582年10月以外の1行目の処理
        for i in range(DW,7):
            if j==chGengo[1]: drawStartGengo(i*50,80)
            CL=setColor(i);isH=isHoliday(Holidays,M,j)
            if isH>=0:#休日のとき
                CL='red'
                canvas.create_text(30+i*50,75,text=Holidays[isH][3],
                                   font=('HGSｺﾞｼｯｸE',6,'normal'),
                                   tag='date',fill=CL)
            drawDate(25+i*50,90,j,CL)
            oldDT=oldDate(Y,M,j)
            canvas.create_text(30+i*50,105,
                               text=oldDateStr(oldDT),
                               font=('HGSｺﾞｼｯｸE',6,'normal'),
                               tag='date',fill='black')
            drawVert(40+i*50,84,rokuyo(oldDT[2],oldDT[3]),10,'green')
            Sekki=retSunT(SunT,j)
            if Sekki!="":
                drawVert(12+i*50,84,Sekki,10,'purple')
            j+=1
    k=-1; YY=90
    for i in range(j,MX+1): # 2行目以降の処理
        k=(k+1) % 7
        if k==0: YY+=40
        if i==chGengo[1]:drawStartGengo(k*50,YY-10)
        CL=setColor(k)
        isH=isHoliday(Holidays,M,i)
        if isH>=0:#休日のとき
            CL='red'
            canvas.create_text(30+k*50,YY-15,text=Holidays[isH][3],
                               font=('HGSｺﾞｼｯｸE',6,'normal'),
                               tag='date',fill=CL)

        drawDate(25+k*50,YY, i, CL)
        oldDT=oldDate(Y,M,i)
        canvas.create_text(30+k*50,YY+15,
                           text=oldDateStr(oldDT),
                           font=('HGSｺﾞｼｯｸE',6,'normal'),
                           tag='date',fill='black')
        drawVert(40+k*50,YY-6,rokuyo(oldDT[2],oldDT[3]),10,'green')

        Sekki=retSunT(SunT,i)
        if Sekki!="":
            drawVert(9+k*50,YY-6,Sekki,10,'purple')

def dspCalendar():
    Y=int(txtY.get("1.0","1.4")) # 1行目4文字取り出し
    M=int(txtM.get("1.0","1.2")) # 1行目2文字取り出し
    Calendar(Y,M)
t=time.localtime() # 現在の日付取り出し
txtY=Text(tk, width=5,height=1);txtY.insert(INSERT,str(t[0]))
txtM=Text(tk, width=3,height=1);txtM.insert(INSERT,str(t[1]))
txtY.place(x =  200, y = 2);txtM.place(x = 270, y = 2)
lblY = Label(tk, text='年', fg='black');lblY.place(x =  240, y = 1)    
lblM = Label(tk, text='月', fg='black');lblM.place(x =  290, y = 1) 
btn1 = Button(tk, text='表示', height=1, command=dspCalendar,
              font=('HGSｺﾞｼｯｸE',10,'normal'))
btn1.place(x = 320, y = 1)
btn2 = Button(tk, text='元号', height=1, command=dspGengo,
              font=('HGSｺﾞｼｯｸE',10,'normal'))
btn2.place(x = 360, y = 1)
tk2.protocol("WM_DELETE_WINDOW",exitProc2) #ウィンドウが閉じられたときexitProcを呼び出し
canvas2.bind("<Button-1>",leftMouseDown)   #元号一覧のときの左ボタンクリック処理 
dspCalendar()
tk.mainloop()

